function bindInvisMarkerFunctions()
{

    $('#background-img').bind('touchstart touchmove touchend touchcancel mousemove mouseout mousedown mouseup', function (e)
    {
        e.preventDefault();
        var data = e.originalEvent;
        if (e.originalEvent.constructor !== MouseEvent)
            data = e.originalEvent.touches[0];


        if (e.type === 'mousedown' || e.type === 'touchstart')
        {
            delete this.oldpageX;
            delete this.oldpageY;
            this.zoomed = false;
            
            if (typeof activeElement === 'undefined' || activeElement === null)
                activeProject.camera[0];
            
            if (typeof activeElement === 'undefined' || activeElement === null)
                return;
            pressed = true;
            showActiveIcon();
            this.tapTime = now();
            animateSidePanel(true);
        }

        if (e.type === 'touchmove')
        {

            if (typeof e.originalEvent.touches[1] !== 'undefined'
                    && !startbymarker)
            {
                this.zoomed = true;
                var x1 = e.originalEvent.touches[0].pageX;
                var y1 = e.originalEvent.touches[0].pageY;
                var x2 = e.originalEvent.touches[1].pageX;
                var y2 = e.originalEvent.touches[1].pageY;

                var a = Math.max(x1, x2) - Math.min(x1, x2);
                var b = Math.max(y1, y2) - Math.min(y1, y2);

                if (modeZoom > 1 && zoom < 1.1)
                {
                    zoomTarget.x = (a + Math.min(x1, x2)) / w;
                    zoomTarget.y = (b + Math.min(y1, y2)) / h;
                }

                var dist = (a + b) / (w + h) * 10;
                if (this.oldDist !== 0)
                    var delta = dist - this.oldDist;
                else
                    var delta = 0;

                if (Math.abs(delta) > 0.005)
                {
                    changeZoom(delta);
                    displayZoom();
                }
                this.oldDist = dist;
            }
            else
            {
                this.oldDist = 0;
            }
        }

        if (e.type === 'touchmove' || e.type === 'mousemove')
        {

            clearTimerSafe(this.tapTimer);

            if (pressed &&
                    (e.originalEvent.constructor === MouseEvent ||
                            typeof e.originalEvent.touches[1] === 'undefined'))
            {

                var dist;
                if (modeZoom === 2)
                {
                    var t = activeElement.markerHTML.offset().top;
                    var l = activeElement.markerHTML.offset().left;
                    dist = Math.sqrt((t - data.pageY) * (t - data.pageY) +
                            (l - data.pageX) * (l - data.pageX));
                }
                if (!panning && (modeZoom !== 2 || zoom < 1.1 || dist < 120))
                {
                    if (!exists(this.tapTime) || now() - this.tapTime > 200)
                    {
                        moveActiveElementByPixel(data.pageX, data.pageY);
                        sendElementData();
                    }
                }
                else
                {
                    if (exists(this.oldpageX) && exists(this.tapTime) && now() - this.tapTime > 200)
                    {
                        panning = true;
                        deb('Panning: x=' + data.pageX + ' y=' + data.pageY, 'zoom');
                        changeZoomTargetpx(
                                (this.oldpageX - data.pageX),
                                (this.oldpageY - data.pageY));
                        recalcZoom();
                    }
                }
            }
        }

        if (e.type === 'mouseup' || e.type === 'touchend' || e.type === 'touchcancel')
        {
            if ((modeZoom === 2 && now() - this.tapTime < 200) ||
                    (modeZoom !== 2 && !this.zoomed) && exists(this.oldpageX) && follow_my_finger)
            {
                moveActiveElementByPixel(this.oldpageX, this.oldpageY);
                sendElementData();
            }
            panning = false;
            pressed = false;
            this.oldDist = 0;
            resetMoveMargins();
        }
        if (exists(data))
        {
            this.oldpageX = data.pageX;
            this.oldpageY = data.pageY;
        }
    }
    );

    $('#background-img').bind('mousewheel DOMMouseScroll', function (event) {
        var d = event.originalEvent.wheelDelta;
        d = (1 - (d < 0) * 2) * 0.1;

        if (zoom < 1.01)
        {
            zoomTarget.x = event.originalEvent.pageX / w;
            zoomTarget.y = event.originalEvent.pageY / h;

            zoomTarget.x = clamp(zoomTarget.x, 0, 1);
            zoomTarget.y = clamp(zoomTarget.y, 0, 1);
        }
        changeZoom(d);
        displayZoom();
    });
}
;



// ****************************************************************************
// Funktion: setBackground
// Neuen Hintergrund setzen. Zu beachten ist: Das Bild muss erst vom Server geladen
//  werden, dann berechnungen, dann bild setzen
// ****************************************************************************
setBackground = function (name)
{
    var path = 'http://' + wsuri + "/project-backgrounds/" + name;
    if ($('#background-img').prop('src') === path)
        return;

    backGroundNotFound = false;
    startLoading('#screen');
    $('.field .camera').css('visibility', 'hidden');
    $('.field .marker').css('visibility', 'hidden');
    $('#background-img').remove();
    $('.field').append('<img id="background-img" alt=" " title=" " ondragstart="return false;" ondrop="return false;"/>');

    var imgErrorFunction = function () {
        $('#background-img').remove();
        $('.field').append('<div id="background-img" ondragstart="return false;" ondrop="return false;"/>');

        $('#background-img').css(
                {
                    'width': '100%',
                    'height': '100%',
                    'margin-top': '0',
                    'margin-left': '0',
                    'top': '0',
                    'left': '0'
                });
        backGroundNotFound = true;
        calc_margin();
    };
    $('#background-img').error(imgErrorFunction);

//	if (name !== '')// || !imgExists('http://'+wsuri+"/project-backgrounds/" + name))
//	{

    name = (!exists(name)) ? '' : name;
    if (name === '')
    {
        imgErrorFunction();
        return;
    }

    $('#background-img').css(
            {
                'margin-top': '100%',
                'margin-left': '100%',
                'top': '100%',
                'left': '100%'
            }
    );

    $('#background-img').prop('src', path);



    $('#background-img').load(calc_margin); //--> width can only be asked if img is loaded
    //calc_margin();
    $(window).resize(function () {
        w = $(window).width();
        h = $(window).height();
        if (typeof menuTimer !== 'undefined')
            clearTimeout(menuTimer);
        menuTimer = setTimeout(function () {
            repositionMenu(false);
            calc_margin();
        }, 300);
    }); //--> update margins on resize
};

calc_margin = function ()
{
    startLoading('#screen');

    if (typeof zoom !== 'undefined' && zoom > 1)
    {
        zoom = 1;
        recalcZoom();
        displayZoom();
    }

    var doc_width = $(document).width();
    var doc_height = $(document).height();

    if (!backGroundNotFound)
    {
        $('#background-img').css(
                {
                    'width': 'auto',
                    'height': 'auto',
                    'margin-top': '100%',
                    'margin-left': '100%',
                    'top': '100%',
                    'left': '100%'
                });
    }
    bgheight = $('#background-img').height();
    bgwidth = $('#background-img').width();

    var screenratio = doc_width / doc_height;
    var bgratio = bgwidth / bgheight;

    if (!isNaN(bgratio))
        if (screenratio < bgratio && !backGroundNotFound)
            $('#background-img').css(
                    {
                        'width': 100 + '%',
                        'height': 'auto'
                    }
            );
        else if (screenratio > bgratio && !backGroundNotFound)
            $('#background-img').css(
                    {
                        'width': 'auto',
                        'height': 100 + '%'
                    }
            );

    bgheight = $('#background-img').height(); //Something could have changed!
    bgwidth = $('#background-img').width();

    if (!backGroundNotFound)
    {
        $('#background-img').css(
                {
                    'margin-top': (doc_height - bgheight) / 2,
                    'margin-left': (doc_width - bgwidth) / 2,
                    'top': '0%',
                    'left': '0%'
                });
    }

    var top = $('#background-img').offset().top;
    var left = $('#background-img').offset().left;
    offsetTop = top;
    offsetLeft = left;

    zoomed_bg_w = bgwidth;
    zoomed_bg_h = bgheight;
    zoomed_top = top;
    zoomed_left = left;

    $('.field .camera').css('visibility', 'visible');
    $('.field .marker').css('visibility', 'visible');

    deb('changed Background: h=' + bgheight + ' w=' + bgwidth + ((backGroundNotFound) ? ' - No IMG' : ''));
    stopLoading('#screen');

//        if (sess !== null && $('#side-panel .item.connect').length > 0)
//        {
//            setTimeout(function () {
//                $('#side-panel .item.connect').removeClass('connect').addClass('active');
//                setTimeout(function () {
//                    $('#side-panel').animate({left: -$('#side-panel').width() + 'px'}, 'fast');
//                }, 500);
//            }, 200);
//        }

    recalculateMarkersCameras();
    bindInvisMarkerFunctions();
    showToolbar();
};

function recalculateMarkersCameras()
{
    var recalc = function (key, marker)
    {
        calcElementPosition(marker);
    };
    $.each(activeProject.camera, recalc);
    $.each(activeProject.marker, recalc);
}

function calcElementPosition(marker, force)
{
    if (marker.visible || (exists(force) && force))
    {
        var pixelX = zoomed_left + (marker.posX * zoomed_bg_w);
        var pixelY = zoomed_top + ((1 - marker.posY) * zoomed_bg_h);
        marker.markerHTML.css({
            'left': pixelX,
            'top': pixelY - 60 / 2
        });
    }
}
