// ****************************************************************************
// Funktion: sendMarkerData
// Bekommt Daten vom Marker �bergeben und baut eine Nachricht zusammen/versendet diese
// ****************************************************************************

connect = function (failed)
{
    wsuri = document.domain + ":" + location.port;

    if (sessionStorage.getItem('wsuri') !== null && failed !== true)
    {
        wsuri = sessionStorage.getItem('wsuri');
        makeOfflineButton();
    }

    if (wsuri === ':')
        wsuri = 'localhost:8080';
    ab.connect("ws://" + wsuri,
            function (session)
            {
                sess = session;
                sess.subscribe("MARKER", wscallback);
                sess.subscribe("BB", wscallback);
//                sess.subscribe("TABLET", wscallback);
                sess.subscribe("CAM", wscallback);
                sess.subscribe("VIEWER", wscallback);
                sess.subscribe("CAMCONF", wscallback);
                sess.subscribe("BBCONF", wscallback);
                sess.subscribe("MODELCONF", wscallback);
                sess.subscribe("VIEWERCONF", wscallback);
                sendWho();
                $('#cubes-overlay, #reconnect').hide();
//                $('.toolbar').show();
                $('.clients .item.active').removeClass('connect');
                stopLoading('#reconnect');
//                    $('#side-panel .item.connect').removeClass('connect').addClass('active');
            },
            function (code, reason)
            {
                sess = null;
                makeOfflineButton();
                setTimeout(function () {
                    connect(exists(failed) ? !failed : true);
                }, 5000);
                return false;
            }
    );
//    }
};

function makeOfflineButton() {
    $(document).ready(function () {
        $('#cubes-overlay, #cubes-overlay *').on('touchmove', function (e) {
            e.preventDefault();
        });
        $('.volatile').remove();
        if ($('#reconnect').css('display') === 'none')
        {
            $('#cubes-overlay, #reconnect').show();
//            $('.toolbar').hide();
        }
        $('.settings').show();
        force_update = true;
        $('#tabs .tab-btn').hide();
        $('#video, #swipe').hide();
        $('.tab-btn').removeClass('active');
        $('#settings').addClass('active');
        $('.section.settings').hide();
        if ($('.section.clients .item').length > 0)
        {
            $('.section.clients').show();
        }
//        $('.toolbar').hide();
        startLoading('#reconnect');
        $('.clients .item.active').addClass('connect');
        if ($('#edddurl').length < 1)
        {
            var value = sessionStorage.getItem('wsuri');
            value = (value === null) ? wsuri : value;
            $('#reconnect .text').html('Connection lost! <br /> Trying to reconnect at' +
                    '<form onsubmit="reloadSite();"><input id="edddurl" value="' + value + '" /></form>');
        }
    });
}

function reloadSite() {
    if ($('#edddurl').val().length > 2)
        sessionStorage.setItem('wsuri', $('#edddurl').val());
    location.reload();
}

function wscallback(channel, payload)
{
    if (debug['connection'])
    {
        if (channel !== 'CAM')
        {
            console.log('\n----------------------------------------------------\n');
            deb('Receiving on Channel: ' + channel, 'connection');
            console.log(payload);
            console.log('----------------------------------------------------\n');
        }
    }

    if (channel === 'VIEWER')
        setViewer(payload);
    else if (/conf/i.test(channel))
        configUpdate(payload, channel);
    else if (channel === 'MARKER')
        markerSet(payload);
    else if (channel === 'CAM')
        camCallback(payload);

    switch (parseInt(payload.cmd))
    {
        case 20:
            backgroundActivate(payload);
            break;
    }
}
;

function camCallback(msg)
{
    if (typeof activeElement !== 'undefined' && activeElement !== null)
    {
        activeElement.realtilt = msg.parms.pa;
        activeElement.z = msg.parms.z;
    }

}


function sendElementData(element)
{

    if (!exists(marker) && typeof activeElement === 'undefined')
        return;

    var marker = exists(element) ? element : activeElement;
    if (exists(marker) && marker !== null)
    {
        var m =
                {
                    id: "MRI_EMU1",
                    type: "TABLET",
                    item: "marker" + marker.num,
                    cmd: 0,
                    parms:
                            {
                                num: marker.num,
                                t: new Date().getTime(),
                                x: marker.posX,
                                y: marker.posY,
                                z: 0.0,
                                ya: marker.angle,
                                pa: 0.0,
                                ra: 0.0,
                                v: (marker.visible ? 1 : 0)
                            }
                };
        if (sess !== null)
        {
            if (debug['connection'])
            {
                console.log('\n----------------------------------------------------\n');
                deb('Sending: ', 'connection');
                console.log(m);
                console.log('----------------------------------------------------\n');
            }
            sess.publish("MARKER", m, true);
        }

    }

}
;


function sendToolbarData(number, angle)
{
    if (sess !== null && (angle > 0 || angle <= 0))
    {
        var m = {
            id: "MRI_EMU1",
            type: "TABLET",
            item: "marker" + number,
            cmd: 0,
            parms:
                    {
                        num: number,
                        t: new Date().getTime(),
                        x: 0,
                        y: 0,
                        z: 0.0,
                        ya: angle,
                        pa: 0.0,
                        ra: 0.0,
                        v: 1
                    }
        };
        if (debug['connection'])
        {
            console.log('\n----------------------------------------------------\n');
            deb('Sending: ', 'connection');
            console.log(m);
            console.log('----------------------------------------------------\n');
        }
        sess.publish("MARKER",
                m, true);
    }
}
;

sendPlanChange = function (plan, activate)
{
    if (sess !== null)
    {
        var m = {
            id: "MRI_EMU1",
            type: "TABLET",
            item: "marker" + plan,
            cmd: 0,
            parms:
                    {
                        num: plan,
                        t: new Date().getTime(),
                        x: 0,
                        y: 0,
                        z: 0.0,
                        ya: 0,
                        pa: 0.0,
                        ra: 0.0,
                        v: (activate ? 1 : 0)
                    }
        };
        if (debug['connection'])
        {
            console.log('\n----------------------------------------------------\n');
            deb('Sending: ', 'connection');
            console.log(m);
            console.log('----------------------------------------------------\n');
        }
        sess.publish("MARKER", m, true);
    }
};

sendMediaData = function (num, visible, angle)
{
    var yaw = exists(angle) ? angle : 0;
    if (sess !== null)
    {
        var m = {
            id: "MRI_EMU1",
            type: "TABLET",
            item: "marker" + num,
            cmd: 0,
            parms:
                    {
                        num: num,
                        t: new Date().getTime(),
                        x: 0,
                        y: 0,
                        z: 0.0,
                        ya: yaw,
                        pa: 0.0,
                        ra: 0.0,
                        v: (visible ? 1 : 0)
                    }
        };
        if (debug['connection'])
        {
            console.log('\n----------------------------------------------------\n');
            deb('Sending: ', 'connection');
            console.log(m);
            console.log('----------------------------------------------------\n');
        }
        sess.publish("MARKER", m, true);
    }
};

sendWho = function ()
{
    var uuid = sessionStorage.getItem('uuid');
    if (uuid === null)
    {
        uuid = navigator.platform + '_' + $.browser.name + '_' +
                $.browser.version + '_' +
                now() + '_' + Math.floor(Math.random() * 1000);
        sessionStorage.setItem('uuid', uuid);
        deb('Generated new ID = ' + uuid, 'main');
    }
    else
        deb('Storage hit - ID = ' + uuid, 'main');
    var m =
            {
                cmd: 100,
                type: "TABLET",
                id: "tablet1",
                parms:
                        {
                            serial: uuid,
                            version: "1.1.0"
                        }
            };
//    if (!isAndroid)
//        sess.call("who", m);
//    else
    if (debug['connection'])
    {
        console.log('\n----------------------------------------------------\n');
        deb('Sending: ', 'connection');
        console.log(m);
        console.log('----------------------------------------------------\n');
    }

    sess.call("who", m);
};

function activateMedia(key, img_num)
{
//    var msg = [2, connector_id, 'showMedia' ,{cmd:61, id:“device123“, parms:{
//key:“VIEWER_asdfadsf“, name:“Der Name als Media ID“}}];
    if (!exists(activeProject.getElementbyKey(key).media[img_num]))
        return;

    var m = {
        cmd: 61,
        id: "tablet1",
        parms:
                {
                    key: key,
                    name: activeProject.getElementbyKey(key).media[img_num].name
                }
    };

    if (debug['connection'])
    {
        console.log('\n----------------------------------------------------\n');
        deb('Sending: ', 'connection');
        console.log(m);
        console.log('----------------------------------------------------\n');
    }
    sess.call('showMedia', m).then(console.log);

}

// ****************************************************************************
// Funktion: processActivate
// Neuen Hintergrund setzen, gesetzt durch Feeder
// ****************************************************************************
backgroundActivate = function (msg)
{
    var path = msg.parms.img;
    setBackground(path);
    var number = msg.parms.num;
    activeBBNumber = number;
    $('#side-panel .BB.section .item').removeClass('active');
    $('#element-num-' + number).addClass('active');
};

// ****************************************************************************
// Funktion: markerSet
// Marker Synchronisation
// ****************************************************************************
markerSet = function (msg)
{
    if (!exists(this.remote_thread))
        this.remote_thread = {};
    this.remote_thread.arg = msg.parms;

    this.remote_thread.busy = true;
    if (exists(this.remote_thread.thread))
    {
        return;
    }

    this.remote_thread.thread = setInterval(function () {
        if (!this.remote_thread.busy)
        {
            clearInterval(this.remote_thread.thread);
            delete this.remote_thread.thread;
        }
        this.remote_thread.busy = false;

        var element = activeProject.getElementbyNumber(this.remote_thread.arg.num);
        if (element === false)
            element = activeProject.getElementbyNumber(this.remote_thread.arg.parms.num);


        if (element === false)
        {
            return;
        }

        if (element.type === 'camera' || element.type === 'marker')
        {
            activeElement = element;
            showActiveIcon();

            if (!element.visible && this.remote_thread.arg.v === 1)
            {
                $('.element-num-' + activeElement.num).show();
                element.visible = 1;
            }
            else if (element.visible && this.remote_thread.arg.v === 0)
            {
                $('.element-num-' + activeElement.num).hide();
                element.visible = 0;
            }

            if (activeElement.posX === this.remote_thread.arg.x && activeElement.posY === this.remote_thread.arg.y &&
                    activeElement.angle === this.remote_thread.arg.ya)
            {
                return;
            }

            activeElement.posX = this.remote_thread.arg.x;
            activeElement.posY = this.remote_thread.arg.y;
            activeElement.angle = this.remote_thread.arg.ya;


            deb(element.type + ' ' + this.remote_thread.arg.num + ' remote controll: x=' + this.remote_thread.arg.x + ' y=' + this.remote_thread.arg.y, 'connection');

            var pixelX = zoomed_left + (this.remote_thread.arg.x * zoomed_bg_w);
            var pixelY = zoomed_top + ((1 - this.remote_thread.arg.y) * zoomed_bg_h);



            activeElement.markerHTML.css({
                'left': pixelX,
                'top': pixelY - 60 / 2
            });

            if (activeElement.isLookAt)
            {
                var target = activeProject.getElementbyNumber(activeElement.target);
                calcLookAtAngle(activeElement, target);
            }
            else if (activeElement.type === 'marker')
            {
                if (exists(activeElement.targetof))
                {
                    var cam = activeProject.getElementbyNumber(activeElement.targetof);
                    calcLookAtAngle(cam, activeElement);
                }
            }

            rotateElement();
            recalcZoom();


        }
        else if (element.obj === 'VIEWER')
        {
            element.angle = this.remote_thread.arg.ya;
        }
    }, 15);
};

setViewer = function (msg)
{
    if (msg.parms.v)
        showMedia(msg.id);
    else
        hideMedia();

    if (msg.parms.type === 'SLIDESHOW' && msg.parms.v === 1)
    {
        var slideshow = activeProject.getElementbyKey(msg.id);
        var number = 0;
        $.each(slideshow.media, function (id, el) {
            if (el.name === msg.parms.name)
                number = id;
        });
        if (number === 0)
            $('#swipe .previous').hide();
        else
            $('#swipe .previous').show();

        if (number === slideshow.media.length - 1)
            $('#swipe .next').hide();
        else
            $('#swipe .next').show();

        $('#side-panel .section.slideshow .item.active').removeClass('active');
        var sa = $('#side-panel .scroll-area');
        var img = $("#side-panel .section.slideshow .item[image-number='" + number + "']");
        img.addClass('active');

        // scroll to active
        if (typeof changeBySwipe !== 'undefined' && changeBySwipe === true)
        {
            var top = $(sa).scrollTop() + img.offset().top - ($(sa).outerHeight() / 2) - 40;
            $('#side-panel .scroll-area').scrollTop(top);
        }

    }
};

// ****************************************************************************
// Funktion: hotspotSet
// Hotspot Synchronisation
// ****************************************************************************
hotspotSet = function (msg)
{
    var marker_number = msg.id;
    var num = activeProject.getHotspotAreaById(marker_number);
    num.moveHotspotAreaOnViewerField(num, msg.parms.lb_x + 32 / screen_x, msg.parms.lb_y);
};

//configUpdate = function (msg) {
////    var active_id = $('#side-panel .fixed-area .active').attr('id');
//    
//    console.log(msg);
////    if (jQuery.isEmptyObject(msg.parms))
////        return;
//
////    if (exists(this.lastmsgcount) && (msg.parms.length === this.lastmsgcount))
////        smallUpdate(msg);
////    else
//        completeUpdate(msg);
//
////    this.lastmsgcount = msg.parms.length;
//};