
function createObject(el)
{
    var element;
    if (el.obj === 'BB')
    {
        element = el;
        activeProject.plan.push(el);

    }
    else if (el.obj === 'CAM')
    {
        element = new MRICamera(el.key, el.num, el.title, el.x, el.y, el.ya,
                el.thumb, el.v, el.lookat, el.target);
        activeProject.camera.push(element);
    }
    else if (el.obj === 'MODEL')
    {
//        console.log(el);
        element = new MRIMarker(el.key, el.num, el.title, el.x, el.y, el.ya,
                el.thumb, el.v);
        activeProject.marker.push(element);
    }
    else if (el.obj === 'VIEWER')
    {
        el.angle = 0;
        element = el;

        activeProject.media.push(el);
    }
    activeProject.addKeyNum2MarkerVal(element);
}


function makeTargetCameraConnection()
{
    $(activeProject.camera).each(function (id, el) {
        if (el.isLookAt)
        {
            var target = activeProject.getElementbyKey(el.target);
            target.targetof = el.key;
        }
    });
}

function updateObject(el)
{
    var element = activeProject.getElementbyKey(el.key);

    if (el.v)
    {
        $('#element-num-' + el.num).addClass('active');
        $('.element-num-' + el.num).show();
        element.visible = true;
    }
    else
    {
        $('#element-num-' + el.num).removeClass('active');
        $('.element-num-' + el.num).hide();
        element.visible = false;
    }
    if (el.obj === 'BB')
    {
//        element = el;
        $('.BB .menu-element').removeClass('active');
        if (typeof activeBBNumber === 'undefined')
            activeBBNumber = activeProject.plan[0].num;

        console.log(activeBBNumber);

        $('#element-num-' + activeBBNumber).addClass('active');

    }
    else if (el.obj === 'CAM')
    {
        element.name = el.title;
        element.target = el.target;
    }
    else if (el.obj === 'MODEL')
    {
        element.name = el.title;
    }
    else if (el.obj === 'VIEWER')
    {
        element = el;
    }
}

function configUpdate(msg, conftype) {
    var type;
    if (!exists(msg.parms[0]) || !exists(msg.parms[0].obj))
    {
        type = conftype.replace('CONF', '');
        $('#' + type).hide();
    }
    else
    {
        type = msg.parms[0].obj;
        $('#' + type).show();
    }

    if (force_update)
    {
        delete this.lastmodellength;
        delete this.lastcamlength;
    }

    if (type === 'MODEL')
    {
        if (exists(this.lastmodellength) && this.lastmodellength === msg.parms.length)
        {
            smallUpdate(msg, type);
            return;
        }
        this.lastmodellength = msg.parms.length;
    }

    if (type === 'CAM')
    {
        if (exists(this.lastcamlength) && this.lastcamlength === msg.parms.length)
        {
            smallUpdate(msg, type);
            return;
        }
        this.lastcamlength = msg.parms.length;
    }
    $('.volatile.' + type).remove();
    resetLists();

    var arg = msg.parms;
    $(arg).each(function (id, el) {
        createMenuElement(el);
        createObject(el);
    });
    makeTargetCameraConnection();
    additionalSetup();
}

function smallUpdate(msg, type) {
    $('#side-panel .volatile.' + type).remove();
    var arg = msg.parms;
    $(arg).each(function (id, el) {
        createMenuElement(el);
        updateObject(el);
    });
    makeTargetCameraConnection();
    additionalSetup();
}

function additionalSetup() {
    var active_id = localStorage.getItem("active_tab");

    if (active_id === null)
    {
        if ($('.tab-btn.BB').css('display') !== 'none')
            active_id = 'BB';
        else if ($('.tab-btn.CAM').css('display') !== 'none')
            active_id = 'CAM';
        else if ($('.tab-btn.MODEL').css('display') !== 'none')
            active_id = 'MODEL';
        else if ($('.tab-btn.VIEWER').css('display') !== 'none')
            active_id = 'VIEWER';
    }

    if ($('#' + active_id).length < 1)
        active_id = 'settings';

    $('#settings').removeClass('active');


    $('#side-panel .BB .item .text, #side-panel .VIEWER .item .text'+
      '#side-panel .MODEL .item .text, #side-panel .CAM .item .text').ellipsis({
        row: 2
    });

    $('#side-panel .section, #side-panel .superior').hide();
    $('#side-panel .' + active_id).show();
    $('#' + active_id).addClass('active');

    if ($('.tab-btn.active').css('display') === 'none')
        active_id = 'settings';
    $('#' + active_id).addClass('active');
    $('#side-panel .' + active_id).show();


//
//    $('#side-panel .item').on('touchstart mousedown touchend mouseup', function () {
//        $('#side-panel .item.active .text').ellipsis({
//            row: 2
//        });
//    });

    addTabFunctions();
    force_update = false;
//    if (typeof activeElement === 'undefined')
//        activeElement = activeProject.camera[0];
    showActiveIcon();
}

function createMenuElement(el) {
    if (!exists(el.obj))
        return;
    var inf = menu_element_info[el.obj];
    if ($('.section.' + el.obj).length === 0)
    {
        $('#side-panel #' + el.obj).show();
        $('#side-panel .scroll-area').append('<div class="section volatile ' + el.obj + '"></div>');
        $('#side-panel .fixed-area').append('<span class="header superior volatile ' + el.obj + '">' + inf.name + '</span>');
    }
    var logo_tag = "<span class=\"icon icon-" + el.thumb + "\"></span>";

    if (el.thumb === '')
        logo_tag = "<span class=\"icon icon-" + inf.icon + "\"></span>";

    if (el.thumb.indexOf('.png') !== -1 || el.thumb.indexOf('.jpg') !== -1)
//        logo_tag = '<img class="icon" src="http://' + wsuri + '/project-backgrounds/' + el.thumb + '" alt=" "/>'
        logo_tag = "<span class=\"icon icon-" + inf.icon + "\"></span>";

    $('#side-panel .section.' + el.obj).append(
            '<div class="item menu-element volatile ' + ((el.v) ? 'active' : '') + '" id="element-num-' + el.num + '">' +
            logo_tag +
            '<span class="text">' + el.title + '</span>' +
            '</div>');

    $('#element-num-' + el.num).attr('marker-num', el.num);
    if (el.obj === 'MODEL' || el.obj === 'CAM')
        addElementFunction(el);
    else if (el.obj === 'BB')
        addBBFunction(el);
    else if (el.obj === 'VIEWER')
    {
        addViewerFunction(el);
        if (el.v)
        {
            setTimeout(function () {
                showMedia(el.key);
            }, 350);
            ;
        }
    }



}
