// ****************************************************************************
// Klasse: MRICamera
// Funktion: Eine bewegbarere Camera
// ****************************************************************************
function MRICamera(key, number, name, posX, posY, angle, logo, visible, isLookAt, target)
{
    this.key = key;
    this.type = 'camera';
    this.num = number;
    this.name = name;
    this.angle = angle;
    this.logo = 'camera';
    if (logo)
        this.logo = logo;
    else
        this.logo = 'camera';
    var logo_tag = '<i class="camera-icon icon-' + this.logo + '"/>';
    this.isLookAt = isLookAt;
    this.target = target;
    this.height = 0;
    this.tilt = 0;
    this.realtilt = 0;
    this.z = 0;
    this.fov = 0;
    this.posX = posX;
    this.posY = posY;
    this.visible = visible;
    this.touched = false;
    this.rotateable = true;

    var html = '<div id="cam-' + this.num + '" class="camera CAM volatile element-num-' + this.num + '">';
    html += '<div class="camera-rotate-handle">' +
            '<div class="direction-triangle">' +
            '<i class="icon-camdirectionright"></i>' +
            '</div>' +
            '</div>';

    html += logo_tag + '</div>';
    this.markerHTML = $(html);

    $('.field').append(this.markerHTML);
    calcElementPosition(this, true);
    bindElementEvents(this);


    if (visible)
    {
        $(this.markerHTML).show();
        $('#element-num-' + this.num).addClass('active');
    }

    this.markerHTML.find('.camera-rotate-handle').css({
        WebkitTransform: 'rotate(' + (-1 * this.angle) + 'deg)',
        MozTransform: 'rotate(' + (-1 * this.angle) + 'deg)',
        transform: 'rotate(' + (-1 * this.angle) + 'deg)' // IE9
    });

}


// ****************************************************************************
// Funktion: 
// 
// ****************************************************************************
MRICamera.prototype.calcAngle = function (posX, posY)
{
    if (!exists(this.pos))
        this.pos = {x: Array(), y: Array(), a: Array()};

    var i = 0;
    var angle = 0;

    var x = 0;
    var y = 0;
    for (; i < (this.pos.x.length - 2); i++)
    {
        x += this.pos.x[i + 1];
        y += this.pos.y[i + 1];
    }

    angle = Math.atan2(x / i - posX, y / i - posY) * (180 / Math.PI);
    if (!isNaN(angle))
    {
        this.pos.a.push(angle + 90);
        if (this.pos.a.length < 2)
            this.angle = angle + 90;
        else
        {
            var a_sum = 0;
            var up = 0;
            var down = 0;
            var count = 0;

            // the following ensures a better handling of the zero crossing
            this.pos.a.forEach(function (el) {
                up += el <= 180;
                down += el > 180;
            });

            this.pos.a.forEach(function (el) {
                if ((up > down && el <= 240) || (up < down && el >= 120))
                {
                    a_sum += el;
                    count++;
                }
            });

            this.angle = a_sum / count;
        }
        if (this.pos.a.length > 12)
        {
            this.pos.a.shift();
        }
    }

    this.pos.x.push(posX);
    this.pos.y.push(posY);

    if (this.pos.x.length > 6)
    {
        this.pos.x.shift();
        this.pos.y.shift();
    }
};



// ****************************************************************************
// Funktion: 
// 
// ****************************************************************************
moveActiveElementByPixel = function (pixelX, pixelY)
{
    this.pixelX = pixelX;
    this.pixelY = pixelY;
    this.busy = true;

    if (modeZoom === 3 && zoom >= 1.01)
    {
        var d_x = Math.max(w * 0.25 - this.oldPixelX, 0) + Math.min(w * 0.75 - this.oldPixelX, 0);
        var d_y = Math.max(h * 0.25 - this.oldPixelY, 0) + Math.min(h * 0.75 - this.oldPixelY, 0);

        d_x = d_x * d_x / w * ((d_x > 0) ? 1 : -1);
        d_y = d_y * d_y / h * ((d_y > 0) ? 1 : -1);

        this.d_x = (zoomTarget.x < 1 && d_x < 0 || zoomTarget.x > 0 && d_x > 0) ? d_x : 0;
        this.d_y = (zoomTarget.y < 1 && d_y < 0 || zoomTarget.y > 0 && d_y > 0) ? d_y : 0;
    }

    if (exists(this.thread))
        return;
    this.thread = setInterval(function () {
        if (!exists(activeElement) ||
                typeof this.pixelX !== 'number' || typeof this.pixelY !== 'number' ||
                this.pixelX + this.pixelY === 0 || !activeElement.visible)
            return;
        if (modeZoom !== 3 && this.oldPixelX === this.pixelX && this.oldPixelY === this.pixelY)
            return;
        if (!busy)
        {
            clearInterval(this.thread);
            delete this.thread;
        }

        this.oldPixelX = this.pixelX;
        this.oldPixelY = this.pixelY;

        var bottom = zoomed_bg_h + zoomed_top;
        var right = zoomed_bg_w + zoomed_left;
        var pixelX = clamp(this.pixelX, zoomed_left, right);
        var pixelY = clamp(this.pixelY, zoomed_top, bottom);

        var realX = (pixelX - zoomed_left) / zoomed_bg_w;
        var realY = 1 - ((pixelY - zoomed_top) / zoomed_bg_h);

        activeElement.posX = realX;
        activeElement.posY = realY;

        deb(activeElement.type + ' ' + activeElement.num + ' moved: x=' + activeElement.posX + ' y=' + activeElement.posY, 'camera');

        if (follow_my_finger && activeElement.type !== 'marker' && !activeElement.isLookAt)
        {
            activeElement.calcAngle(realX, 1 - realY);
            rotateElement();
        }
        else if (activeElement.isLookAt)
        {
            var target = activeProject.getElementbyKey(activeElement.target);
            calcLookAtAngle(activeElement, target);
        }
        else if (activeElement.type === 'marker')
        {
            if (exists(activeElement.targetof))
            {
                var cam = activeProject.getElementbyKey(activeElement.targetof);
                calcLookAtAngle(cam, activeElement);
            }
        }

        var move_tb = w - pixelX - 60 - 60 / 2 - 3;
        var move_settingsx = pixelX - 60 - 60 / 2 - 3;
        var move_zoom_info = pixelY - 45 - 45 / 2 - 3;

        move_bar = function (move_val, bar, margin, dim) {
            if (!pressed)
                return;
            var pixel = pixelY; // x-Axis
            var ref = $(bar).offset().top;
            var length = $(bar).outerHeight();
            if (dim === 1) // y-Axis
            {
                pixel = pixelX;
                ref = $(bar).offset().left;
                length = $(bar).outerWidth();
            }

            if (move_val < 0 && pixel + 60 / 2 > ref &&
                    (pixel - 60 / 2) < (ref + length))
            {
                $(bar).css(margin, move_val);
            }
            else if (move_val < 60)
                $(bar).css(margin, 0);
        };

        move_bar(move_tb, '.toolbar', 'margin-right', 0);
        move_bar(move_zoom_info, '#zoom-info', 'margin-top', 1);
        move_bar(move_settingsx, '#menu-btn', 'margin-left', 0);

        activeElement.markerHTML.css({
            'left': pixelX,
            'top': pixelY - 60 / 2
        });

        if (modeZoom === 3 && zoom >= 1.01)
        {
            changeZoomTargetpx(-this.d_x, -this.d_y);
            if ((this.d_y !== 0 || this.d_x !== 0) && pressed)
            {
                clearTimerSafe(this.moveTimer);
                this.moveTimer = setTimeout(function () {
                    moveActiveElementByPixel(this.pixelX, this.pixelY);
                    sendElementData();
                }, 10);
            }
        }
        recalcZoom();

        this.busy = false;
    }, 15);
//    deb('max frame rate='+ maxFrameRate,'camera');
};

function calcLookAtAngle(cam, target)
{

    cam.angle = Math.atan2(cam.posY - target.posY,
            cam.posX - target.posX) * (180 / Math.PI) - 180;

    if (target === false)
    {
        cam.angle = Math.atan2(cam.posY - 0.5,
                cam.posX - 0.5) * (180 / Math.PI) - 180;
    }
    rotateElement(cam);
}


// ****************************************************************************
// Funktion: 
// 
// ****************************************************************************
function calcTouch2Angle(event)
{

    var y1 = event.originalEvent.touches[0].clientY;
    var y2 = event.originalEvent.touches[1].clientY;
    var x1 = event.originalEvent.touches[0].clientX;
    var x2 = event.originalEvent.touches[1].clientX;

    var a = Math.abs(y1 - y2);
    var b = Math.abs(x1 - x2);
    var c = Math.sqrt(a * a + b + b);
    var beta = Math.atan2(a, b) * 180 / Math.PI;

    var diffX = x1 - x2;
    var diffY = y1 - y2;

    // 1 ... 180 bis 270 Grad
    if (diffX > 0 && diffY > 0)
    {
        beta += 180;
    }
    // 2 ... 90 - 180 Grad
    if (diffX > 0 && diffY < 0)
    {
        beta *= -1;
        beta += 180;
    }
    // 3 ... 0 bis 90 Grad
    if (diffX < 0 && diffY < 0)
    {
        beta *= 1;
    }
    // 4 ... 270 bis 360 Grad
    if (diffX < 0 && diffY > 0)
    {
        beta *= -1;
        beta += 360;
    }

    return beta;
}



// ****************************************************************************
// Funktion: 
// 
// ****************************************************************************
function bindElementEvents(element)
{
    $(element.markerHTML).on('mousedown touchstart', function (event)
    {
        event.preventDefault();
        activeElement = element;
        pressed = true;
        startbymarker = true;
        showActiveIcon(element.type);
        recalcZoom();
        animateSidePanel(true);
    });

    $(element.markerHTML).on('mousemove touchmove', function (event)
    {

        if (panning)
            return;

        event.preventDefault();
        var data = event.originalEvent;
        if (event.originalEvent.constructor !== MouseEvent)
            data = event.originalEvent.touches[0];

        if (event.originalEvent.constructor !== MouseEvent &&
                typeof event.originalEvent.touches[1] !== 'undefined' &&
                (!follow_my_finger || activeElement.type === 'marker'))
        {
            if (exists(this.old))
            {
                var delta = this.old - calcTouch2Angle(event);
                if (Math.abs(delta) < 15)
                {
                    activeElement.angle = activeElement.angle + delta;
                    sendElementData();
                    rotateElement();
                }
            }
            this.old = calcTouch2Angle(event);
        }
        else if (pressed)
        {
            moveActiveElementByPixel(data.pageX, data.pageY);
            sendElementData();
        }
    });

    $(element.markerHTML).on('mouseup touchend touchcancel', function (event)
    {
        event.preventDefault();
        pressed = false;
        panning = false;
        startbymarker = false;
        resetMoveMargins();
    });

    $(element.markerHTML).on('mousewheel DOMMouseScroll', function (event)
    {
        var d = event.originalEvent.wheelDelta;
        d = (1 - (d > 0) * 2) * 10;
        element.angle += d;
        rotateElement();
        activeElement = element;
        showActiveIcon(element.type);
        //sendCameraData();
        sendElementData();

    });
}


// ****************************************************************************
// Funktion: 
// 
// ****************************************************************************
function showActiveIcon()
{
    $('.camera, .marker').removeClass('active');
    if (typeof activeElement === 'undefined')
    {
        var active_num = localStorage.getItem("active_element_num");
        activeElement = activeProject.getElementbyNumber(active_num);
        if (!activeElement)
            activeElement = activeProject.camera[0];
    }
    if (typeof activeElement !== 'undefined')
    {
        $('.element-num-' + activeElement.num).addClass('active');
        localStorage.setItem("active_element_num", activeElement.num);
    }
    showToolbar();
}
;


// ****************************************************************************
// Klasse: MRIMarker
// Funktion: Ein bewegbarer Marker
// ****************************************************************************
function MRIMarker(key, number, name, posX, posY, angle, logo, visible)
{
    this.key = key;
    this.type = 'marker';
    this.num = number;
    this.name = name;
    this.angle = angle;
    this.logo = logo;
    var logo_tag = '<i class="marker-icon icon-cube"/>';
    this.height = 0;
    this.tilt = 0;
    this.posX = posX;
    this.posY = posY;
    this.visible = visible;
    this.showLabel = true;
    this.targetof;
    this.markerHTML = $('<div id="marker-' + this.num + '" class="marker MODEL volatile element-num-' + this.num + '">\
			                        ' + logo_tag + '\
									<span>' + name + '</span>\
			                      </div>'); // TODO: set correct icon
    this.overlay = $('<div class="move-overlay"></div>');

    $('.field').append(this.markerHTML);
    calcElementPosition(this, true);
    bindElementEvents(this);

    if (visible)
    {
        $(this.markerHTML).show();
        $('#element-num-' + this.num).addClass('active');
    }

    this.markerHTML.css({
        WebkitTransform: 'rotate(' + (-1 * this.angle) + 'deg)',
        MozTransform: 'rotate(' + (-1 * this.angle) + 'deg)',
        transform: 'rotate(' + (-1 * this.angle) + 'deg)' // IE9
    });
}

MRIMarker.prototype.calculateNewPosition = function (posX, posY)
{
    moveMarkerOnViewerField(activeMarker.num, posX, posY, false);
    sendMarkerData(activeMarker);
};

function remoteMarker(number, x, y, a)
{
    var marker = activeProject.getMarkerByNumber(number);
    activeMarker = marker;
    activeMarker.posX = x;
    activeMarker.posY = y;
    activeMarker.angle = a;
    moveMarkerOnViewerField();
    showMarkerToolbar();
    showActiveIcon('marker');
}

// ****************************************************************************
// Funktion: moveMarkerOnViewerField
// Bewegt einen Marker auf den Punkt (x,y)
// ****************************************************************************
moveMarkerOnViewerField = function ()
{
    if (activeMarker.posX != 0 && activeMarker.PosY != 0)
    {
        var pixelX = activeMarker.posX * bgwidth + offsetLeft;
        var pixelY = bgheight - activeMarker.posY * bgheight + offsetTop;
        activeMarker.moveToNewPos(pixelX, pixelY);
    }
    activeMarker.markerHTML.css(
            {
                WebkitTransform: 'rotate(' + (-1 * activeMarker.angle) + 'deg)',
                MozTransform: 'rotate(' + (-1 * activeMarker.angle) + 'deg)',
                transform: 'rotate(' + (-1 * activeMarker.angle) + 'deg)' // IE9
            }
    );

    activeMarker.markerHTML.css(
            {
                'left': pixelX,
                'top': pixelY - 60 / 2
            }
    );
};
