/*
 * Copyright (c) 2010 Animesh Kumar  (https://github.com/anismiles)
 * Copyright (c) 2010 Strumsoft  (https://strumsoft.com)
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */
(function() 
{
    // window object
    var global = window;
    var is_android = false;

    // WebSocket Object. All listener methods are cleaned up!
    var WebSocket = global.WebSocket = function()
	{
        // get a new websocket object from factory (check com.strumsoft.websocket.WebSocketFactory.java)
		
			try
			{
				this.socket = WebSocketFactory.getInstance();
				//console.log("GAP FOUND");
				Android.setGapWorking();
				//console.log("GAP FOUND 2");
			}
			catch(err)
			{
				//console.log("GAP: ERROR");
				window.close();
			}
			//this.socket.killTestingThread();
		
        // store in registry
        /*if(this.socket) {
         WebSocket.store[this.socket.getId()] = this;
         } else {
         throw new Error('Websocket instantiation failed! Address might be wrong.');
         }*/
    };

    // private property
    WebSocket._keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

    // private method for decoding base64
    WebSocket._decode = function(input) 
	{
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) 
		{
            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) output = output + String.fromCharCode(chr2);
            if (enc4 != 64) output = output + String.fromCharCode(chr3);
        }
        output = this._utf8_decode(output);
        return output;
    }

    // private method for UTF-8 decoding
    WebSocket._utf8_decode = function(utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
        while (i < utftext.length) 
		{
            c = utftext.charCodeAt(i);
            if (c < 128) 
			{
                string += String.fromCharCode(c);
                i++;
            }
			else if ((c > 191) && (c < 224)) 
			{
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else
			{
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }

    //  -------------------------------------------------------------------------
    //  KOMMERZ START
    //  -------------------------------------------------------------------------

	
    // storage to hold websocket object for later invokation of event methods
    WebSocket.store = {};
	
	WebSocket.test = function()
	{
		console.log("GAP: TEST COMPLETE");
	}
	
    WebSocket.onopen = function(evt) 
	{
        //console.log("onopen1");
        WebSocket.store[evt._target]['onopen'].call(global, evt);
    };

    WebSocket.onclose = function(evt) 
	{
        //console.log("onclose1");
        WebSocket.store[evt._target]['onclose'].call(global, evt);
    };
       
    WebSocket.onmessage = function(evt) 
	{
        //console.log("onmessage1");
        WebSocket.store[evt._target]['onmessage'].call(global, this._decode(evt._data));
    };
    
    WebSocket.onerror = function(evt) 
	{
        //console.log("onerror1");
        WebSocket.store[evt._target]['onerror'].call(global, evt);
    };
    
    //  -------------------------------------------------------------------------
    //  methods called on java src
    //  -------------------------------------------------------------------------
        
    WebSocket.prototype.subscribe = function(topic)
	{
        this.socket.subscribe(topic);
        //console.log("subscribe websocket.js");
    };
    
    WebSocket.prototype.onPublish = function(topic, msg) 
	{   
		dummy(topic, msg);
		//console.log("onPublish websocket.js  "+msg);
    };
    
    WebSocket.prototype.publish = function(topic, data, excludeMe)
	{
	
        this.socket.publishMarker(data.id, data.item, data.cmd, data.parms.num, data.parms.t, data.parms.x, data.parms.y, data.parms.z,
		data.parms.ya, data.parms.pa, data.parms.ra, data.parms.v, true);
		
    };
    
	/*
	NEUE VERSION
    WebSocket.prototype.call = function(method_name, arg1, arg2)
	{
		//console.log("MARTIN: "+method_name, arg);
        this.socket.callWho(method_name, arg1, arg2);
		//console.log("call websocket.js");
    };
	*/
    WebSocket.prototype.call = function(method_name, arg1)
	{
		//console.log("MARTIN: "+method_name, arg);
        this.socket.callWho(method_name, arg1);
		//console.log("call websocket.js");
    };
    
    WebSocket.prototype.close = function()
	{
        this.socket.close();
		//console.log("close websocket.js");
    };
    
    WebSocket.prototype.send = function(data)
	{
        this.socket.send(data);
        //console.log("send websocket.js");
    };
    
    WebSocket.prototype.getReadyState = function()
	{    
        this.socket.getReadyState();
        //console.log("getReadyState websocket.js");
    };
	
	WebSocket.prototype.getXDPI = function()
	{
		var dpi = this.socket.getXDPI();
		//console.log("getXDPI:"+dpi);
	};
	
	WebSocket.prototype.getYDPI = function()
	{
		var dpi = this.socket.getYDPI();
		//console.log("getYDPI:"+dpi);
	};
	
	WebSocket.prototype.getDisplayMetricConstant = function() 
	{
		var dpi = this.socket.getDisplayMetricConstant();
		//console.log("getDisplayMetricConstant:"+dpi);
	};
	
	WebSocket.prototype.killTestingThread = function() 
	{
		console.log("gap: test 4");
		this.socket.killTestingThread();
	};
	
})();
