// Debug Section
var debug = {
    'main': true,
    'camera': false,
    'marker': true,
    'toolbar': true,
    'connection': false,
    'zoom': false,
    'gui': true
};

var w = $(window).width();
var h = $(window).height();

var started = now();

var zoom = 1;
var maxZoom = 5;
var modeZoom = 0;
if (localStorage.getItem('pan-mode') === null)
    localStorage.setItem('pan-mode', 'zoom-corner');

var zoomTarget = {x: 0.5, y: 0.5};
var oldPixelX = 0;
var oldPixelY = 0;
var oldCalcTime = 0;
var oldDist = 0;
var maxFrameRate = 10;

// Background + BG-Image
var backGroundNotFound = false;
var bgheight = 0;
var bgwidth = 0;
var offsetLeft = 0;
var offsetTop = 0;

// Toolbar
var height_marker = 3;
var tilt_marker = 4;
var fov_marker = 5;

// Camera + Marker
var startbymarker = false;
var pressed = false;
var panning = false;

var follow_my_finger = false;
// Swipe
var activeSwipe;

var swipe_treshold = 50;

var menu_element_info = {
    'BB': {name: 'Floorplans', icon: 'floorplan', after: ''},
    'CAM': {name: 'Cameras', icon: 'camera', after: ' #BB'},
    'VIEWER': {name: 'Media', icon: 'media', after: ' #MODEL'},
    'MODEL': {name: 'Moveables', icon: 'cube', after: ' #CAM'}
};


var drag_counter = 0;
var swipeIncrementValue = 90;
var force_update = false;

// Unique instance ID
var connector_id;

function toggleActive(object)
{
    if (object.hasClass('active'))
        object.removeClass('active');
    else
        object.addClass('active');
}

function now()
{
    return (new Date()).getTime();
}

function clamp(val, min, max)
{
    return Math.min(Math.max(val, min), max);
}

function exists(val) {
    return typeof val !== 'undefined';
}

function clearTimerSafe(timer) {
    if (typeof timer !== 'undefined')
        clearTimeout(timer);
}

function deb(str, channel) {
    if (typeof channel === 'undefined')
    {
        channel = 'main';
    }
    if (debug[channel])
        console.log(channel.toUpperCase() + ': ' + str); //+ ' @' + (now() - started) + 's');
}

function makeSVG(tag, attrs) {
    var el = document.createElementNS('http://www.w3.org/2000/svg', tag);
    for (var k in attrs)
        el.setAttribute(k, attrs[k]);
    return el;
}


function makeLoader(tag)
{
    for (var i = 0; i < 3; i++)
    {
        $(tag + ' .loader').append(makeSVG('circle', {
            'class': 'c' + i,
            'cx': 28 + i * 22,
            'cy': 14,
            'r': 7
        }));
    }
}

function makeSmallLoader(tag)
{
    for (var i = 0; i < 3; i++)
    {
        $(tag + ' .loader').append(makeSVG('circle', {
            'class': 'c' + i,
            'cx': 34 + i * 12,
            'cy': 10,
            'r': 4
        }));
    }
}

function startLoading(tag, small) {
    if ($(tag + ' .loader').length > 0)
        return;
    $(tag).append('<svg class="loader"><svg>');


    if (small)
        makeSmallLoader(tag);
    else
        makeLoader(tag);


    $(tag + ' .loader circle').css({opacity: 0});

    var speed = 500;
    var counter = 0;

    setTimeout(function () {
        var loadingthread = setInterval(function () {
            if ($(tag + ' .loader .c0').css("opacity") === '0')
                counter = 0;

            if ($(tag + ' .loader .c0').css("opacity") === '0' ||
                    $(tag + ' .loader .c1').css("opacity") === '0' ||
                    $(tag + ' .loader .c2').css("opacity") === '0')
            {
                $(tag + ' .loader .c' + counter).animate({opacity: 1}, speed);
                counter = (counter + 1) % 3;
            }
            else
            {
                counter = Math.floor(now() / speed % 3);
                $(tag + ' .loader .c' + counter).animate({opacity: 1}, speed);
                $(tag + ' .loader .c' + ((counter + 2) % 3)).animate({opacity: 0.3}, speed);
                $(tag + ' .loader .c' + ((counter + 1) % 3)).animate({opacity: 0.3}, speed);
            }
        }, speed);

        $(tag + ' .loader').attr('loadingthread', loadingthread);

    }, speed);
}

function stopLoading(tag) {
    if ($(tag + ' .loader').length < 1)
        return;
    clearInterval($(tag + ' .loader').attr('loadingthread'));
    $(tag + ' .loader').remove();
}

function updateClients(clients)
{
    if (exists(this.lock) && this.lock === true)
        return;
    this.lock = true;
    $('#side-panel .settings.browser').remove();
    $('#dialog .searching').removeClass('center');
    $('#side-panel .scroll-area .clients').remove();
    $('#side-panel .scroll-area').prepend(
            '<div class="settings section clients">' +
            '<span class="header">Project</span>' +
            '<span class="anchor"></span>' +
            '<div class="btn toggle-dialog">Search for edddison projects</div>' +
            '</div>');

    if ($('#settings').hasClass('active'))
    {
        $('#side-panel .scroll-area .clients').show();
    }
    $('.section.clients .item').remove();
    $(clients).each(function (id, string) {
        var str = 
                '<a href="http://' + string[1] + '" class="item menu-element ' + (exists(string[3]) ? 'active' : '') + '">' +
                '<span class="icon icon-client"></span>' +
                '<span class="text">' + string[2] +
                '<span class="small">' + string[0] + '</span>'+
                '</span>' +
                '</a>';
        $('#side-panel .section.clients .anchor').append(str);
        $('#dialog .section.clients .anchor').after(str);
    });

    $('#side-panel .toggle-dialog').on('touchstart mousedown', function (e) {
        e.preventDefault();
        $('#dialog').toggleClass('active');
        $('#blur-plane').toggleClass('active');
    });
    this.lock = false;
}


//setTimeout(function () {
//    $(document).ready(updateClients([['MagicY', 'localhost:8383', 'Project 1', 1],['MagicY', 'localhost:8383', 'Project 1'],['MagicY', 'localhost:8383', 'Project 1']]));
//}, 50);