// ****************************************************************************
// Funktion: startProjectByName
// Projekt starten. Hauproutine!
// ****************************************************************************
$(document).ready(function () {
    var project = new MRIProject('default', 0);
    if (location.hash === '#start')
    {
        $('#side-panel, .wrapper, .toggle-dialog').hide();
        $('#dialog').addClass('active');
        startLoading('#dialog .searching',true);
    }
    else if(location.hash === '#backprojection')
    {
        $('body').attr('id', "back-projection");
        $('#side-panel, .toolbar').remove();
        initEmulator(project);
    }
    else
    {
        initEmulator(project);
        startLoading('#dialog .searching',true);
    }
});


initEmulator = function (project)
{
    connect();
    if (project)
    {

        function is_touch_device() {
            try {
                document.createEvent("TouchEvent");
                return true;
            } catch (e) {
                return false;
            }
        }
        console.log('Is Touch Device: ' + is_touch_device());

        activeProject = project;

        var fieldHTML = $("<div unselectable='on'></div>").attr('class', 'field');
//        var projectHTML = $("<div></div>").attr('class', 'project').attr('id', 'project-' + name);

        $('#screen').append(fieldHTML);

        setBackground('');

        var movebox = $("<div></div>").attr('class', 'movebox');

        fieldHTML.append(movebox);
        $(".movebox").hide();

        createMenu();
        addMenuFunctions();
        repositionMenu(true);

        if (localStorage.getItem('zoom-mode') !== null
                && localStorage.getItem('zoom-mode') !== '0')
        {
            modeZoom = parseInt(localStorage.getItem('zoom-mode'));
            $('#side-panel .pan-mode.collection').addClass('active');
            $('#side-panel #' + localStorage.getItem('pan-mode')).addClass('active');
        }
        if (localStorage.getItem('follow-my-finger') === 'false')
        {
            follow_my_finger = false;
            $('#side-panel .nav-mode .item').removeClass('active');
            $('#side-panel #multi-touch').addClass('active');
        }
//        if(sessionStorage.getItem('lastmsg') !== null)
//        {
//            configUpdate(JSON.parse(sessionStorage.getItem('lastmsg')));
//        }
    }
};


// ****************************************************************************
// Klasse: MRIProject
// Funktion: Stellt eine Applikation im Emulator dar
// ****************************************************************************/
function MRIProject()
{
    this.camera = new Array();
    this.marker = new Array();
    this.object = new Array();
    this.texture = new Array();
    this.view = new Array();
    this.plan = new Array();
    this.media = new Array();

    this.Number2Element = new Array();
    this.Key2Element = new Array();
}

MRIProject.prototype.addKeyNum2MarkerVal = function (element)
{
    this.Number2Element[element.num] = element;
    this.Key2Element[element.key] = element;
};


MRIProject.prototype.getElementbyNumber = function (markerNumber)
{
    markerNumber = parseInt(markerNumber);

    if (exists(this.Number2Element[markerNumber]))
        return this.Number2Element[markerNumber];

    return false;
};

MRIProject.prototype.getElementbyKey = function (key)
{

    if (exists(this.Key2Element[key]))
        return this.Key2Element[key];

    return false;
};

function resetLists()
{
    this.Number2Element = new Array();
    this.camera = new Array();
    this.marker = new Array();
    this.object = new Array();
    this.texture = new Array();
    this.view = new Array();
    this.plan = new Array();
    this.media = new Array();
}
