function addMenuFunctions()
{
    //-----------------------------------------------------------------------------------------------
    // Toolbar Functions
    //-----------------------------------------------------------------------------------------------
    $('.right_close').on('touchend mouseup', function (e) {
        e.preventDefault();
        if (exists($('.toolbar')[0].drag_counter) && $('.toolbar')[0].drag_counter > 2)
            return;
        $('.toolbar').animate({right: -60 + 'px'}, 'fast');
        $('.right_open').animate({right: 60 + 'px'}, 'fast');
    });

    $('.right_open').on('touchend mouseup', function (e) {
        e.preventDefault();
        if (exists($('.toolbar')[0].drag_counter) && $('.toolbar')[0].drag_counter > 2)
            return;
        $('.toolbar').animate({right: 0 + 'px'}, 'fast');
        $('.right_open').animate({right: -60 + 'px'}, 'fast');
    });

    //--------------------------------------------------------------------------
    // side-panel
    //--------------------------------------------------------------------------

    $('#side-panel .scroll-area').on('touchmove', function (e) {
        if ($(e.currentTarget)[0].scrollHeight <= $(e.currentTarget).outerHeight())
            e.preventDefault();
    });

    $('#side-panel .scroll-area').scroll(function (e) {
        drag_counter++;
        clearTimerSafe(this.resettimer);
        this.resettimer = setTimeout(function () {
            drag_counter = 0;
        }, 1000);
    });

    $('#menu-btn').on('touchstart mousedown', function (e) {
        e.preventDefault();
        animateSidePanel($('#side-panel').offset().left > -150);
    });

    $('.toggle-dialog').on('touchstart mousedown', function (e) {
        e.preventDefault();
        $('#dialog').toggleClass('active');
        $('#blur-plane').toggleClass('active');
    });

    $('#side-panel .drag, .touchplane').on('touchstart touchmove touchend touchcancel', function (e) {
        if (!$(e.currentTarget).hasClass('scroll-area') && e.cancelable)// && $(e.currentTarget).attr('id') !== 'settings')
            e.preventDefault();
        var data = e.originalEvent;
        if (e.originalEvent.constructor !== MouseEvent)
            data = e.originalEvent.touches[0];

        if (e.type === 'touchstart')
        {

            if (exists(this.taptime) && now() - this.taptime < 150)
                return;

            this.pressed = true;
            this.sumdeltax = 0;
            this.sumdeltay = 0;
            this.symbolmargin = parseInt($('#menu-btn .close').css('margin-left'));

            this.taptime = now();
            $('.touchplane').show();
        }
        if (e.type === 'touchmove')
        {
            if (this.pressed === false)
                return;
            drag_counter += 1;

            var dx = data.pageX - this.oldpageX;
            var dy = data.pageY - this.oldpageY;
            if ((this.sumdeltax < -30 && this.sumdeltay < 30) || $('#side-panel').offset().left < 0)
            {
                $('#side-panel').css({left: clamp($('#side-panel').offset().left + dx, -$('#side-panel').width(), 0) + 'px'});

                this.symbolmargin += dx / 4;
                var symmar = this.symbolmargin;
                $('#menu-btn .close').css({marginLeft: clamp(
                            symmar, -60, 0) + 'px'});
                $('#menu-btn .open').css({marginLeft: clamp(
                            symmar + 60, 0, 60) + 'px'});

//                clearTimerSafe(this.animationtimer);
//                this.animationtimer = setTimeout(function () {
//
////                    var dist = $('#side-panel').offset().left;
////                    $('#cubes-overlay .wrapper').css({
////                        width: w - 300 - dist + 'px',
////                        left: 300 + dist + 'px'
////                    });
//                }, 15);


//                $('#menu-btn .open').animate({marginLeft: 0 + 'px'}, 500);
            }
            this.olddelta = dx;
            this.sumdeltax += dx;
            this.sumdeltay += Math.abs(dy);
        }
        if (e.type === 'touchend' || e.type === 'touchcancel')
        {
            if (!this.pressed)
                return;
            var left = $('#side-panel').offset().left;
            var closed = left < -150;

            animateSidePanel(closed || this.sumdeltax < -80);

            $('.touchplane').hide();
            this.pressed = false;
        }

        if (exists(data))
        {
            this.oldpageX = data.pageX;
            this.oldpageY = data.pageY;
        }
    });

    $('#side-panel .pan-mode.collection .item').on('touchend mouseup', function (e) {
        if (!validateEvent(e))
            return;
        if ($(this).hasClass('head'))
        {
            $('.pan-mode.collection').toggleClass('active');
            changeZoom(-1000);
            displayZoom();
            $('#side-panel .scroll-area').scrollTop($('.pan-mode.collection .item.minor').outerHeight() * 10);
        }

        $('#side-panel .pan-mode .minor').removeClass('active');

        if ($('#side-panel .pan-mode.collection').hasClass('active'))
        {
            if ($(this).hasClass('minor'))
            {
                $(this).addClass('active');
            }
            var active = $('#side-panel .pan-mode .minor.active');
            if ($(active).attr('id') === 'zoom-auto')
                modeZoom = 1;
            else if ($(active).attr('id') === 'zoom-pan')
                modeZoom = 2;
            else if ($(active).attr('id') === 'zoom-corner')
                modeZoom = 3;
            else if (active.length === 0)
            {
                $('#side-panel #' + localStorage.getItem('pan-mode')).addClass('active');
                modeZoom = 3;
            }
            if (active.length !== 0)
            {
                localStorage.setItem('pan-mode', $(active).attr('id'));
            }
        }
        else
        {
            modeZoom = 0;
        }
        localStorage.setItem('zoom-mode', modeZoom);
        showToolbar();
        if (modeZoom !== 0 && backGroundNotFound)
        {
            writeInfoText('You need an image to zoom');
        }
    });

    $('#side-panel .nav-mode .item').on('touchend mouseup', function (e) {
        if (!validateEvent(e))
            return;
        follow_my_finger = $(this).attr('id') === 'follow-my-finger';
        localStorage.setItem('follow-my-finger', follow_my_finger);
        $('#side-panel .nav-mode .item').removeClass('active');
        $(e.currentTarget).addClass('active');
    });

    $('#side-panel .icon-help').on('touchend mouseup', function (e) {
        if (!validateEvent(e))
            return;
        if ($(e.currentTarget).hasClass('active'))
        {
            $(e.currentTarget).removeClass('active');
            $(e.currentTarget).parent().find('.help').hide();

        }
        else
        {
            $('.icon-help').removeClass('active');
            $('.help').hide();

            $(e.currentTarget).addClass('active');
            var help = $(e.currentTarget).parent().find('.help');
            var s_h = $('#side-panel .scroll-area')[0].scrollHeight;
            var s_pos = $('#side-panel .scroll-area').scrollTop();
            var s_top = $('#side-panel .scroll-area').offset().top;
            var btn_top = $(this).offset().top;
            var h_h = $('.header').first().outerHeight(true);
            var ls = $('#side-panel .settings.collection');

//            console.log(ls.offset().top+ls.outerHeight());
//            if(ls.offset().top+ls.outerHeight() === 0)
//            {
//                ls = $('#side-panel .settings.section').last();
//            }

            help.css({height: ls.offset().top + ls.outerHeight(true) - h_h - btn_top + 'px'});

            help.show();
//            help.fadeIn();
        }
        this.lastcall = now();
    });
    $('#side-panel .help').on('touchend mouseup', function (e) {
        if (!validateEvent(e))
            return;
        $(e.currentTarget).parent().find('.icon-help').removeClass('active');
        $(e.currentTarget).hide();
    });
}

$(document).ready(function () {
    $('#zoom-info').on('touchend mouseup', function () {
        changeZoom(-1000);
        displayZoom();
    });

    $('#dialog .icon-help').on('touchend mouseup', function (e) {
        e.preventDefault();
        $('#dialog .footer .icon-help').toggleClass('active');
        if ($('#dialog .footer .icon-help').hasClass('active'))
        {
            $('#dialog .footer .text').hide();
            $('#dialog .footer .help .text, #dialog .footer .help').show();
        }
        else
        {
            $('#dialog .footer .text').show();
            $('#dialog .footer .help .text, #dialog .footer .help').hide();
        }

    });
});




$(document).ready(function () {
// full-screen available?
    if (
            document.fullscreenEnabled ||
            document.webkitFullscreenEnabled ||
            document.mozFullScreenEnabled ||
            document.msFullscreenEnabled
            )
    {
        if ($('.tab-btn.active').attr('id') === 'settings')
            $('#side-panel .settings.browser').show();
    }
    else {
        $('#side-panel .settings.browser').remove();
    }


    $(window).on('resize', function () {
        if (document.fullscreenElement ||
                document.webkitFullscreenElement ||
                document.mozFullScreenElement ||
                document.msFullscreenElement)
        {
            console.log('return');
            this.api_used = true;
            return; // -> Fullscreen API was used (nothing to do)
        }
        if (exists(this.api_used) && this.api_used)
        {
            this.api_used = false;
            return;
        }

//        console.log(screen.height);
//        console.log(window.innerHeight);
        if (screen.height === window.innerHeight)
            $('#side-panel .settings.browser .fullscreen').addClass('active');
        else
            $('#side-panel .settings.browser .fullscreen').removeClass('active');
    });

    $('#side-panel .settings.browser .fullscreen').click(function () {
        var element = $('html')[0];
        function exitFullscreen() {
            if (document.exitFullscreen) {
                document.exitFullscreen();
            } else if (document.mozCancelFullScreen) {
                document.mozCancelFullScreen();
            } else if (document.webkitExitFullscreen) {
                document.webkitExitFullscreen();
            } else if (document.msExitFullscreen) {
                document.msExitFullscreen();
            }
            $('#side-panel .settings.browser .fullscreen').removeClass('active');
        }

        function goFullscreen(element) {
            if (element.requestFullscreen) {
                element.requestFullscreen();
            } else if (element.mozRequestFullScreen) {
                element.mozRequestFullScreen();
            } else if (element.webkitRequestFullscreen) {
                element.webkitRequestFullscreen();
            } else if (element.msRequestFullscreen) {
                element.msRequestFullscreen();
            }
            $('#side-panel .settings.browser .fullscreen').addClass('active');
        }

        if (!$(this).hasClass('active'))
        {
            goFullscreen(element);
        }
        else
        {
            exitFullscreen();
        }
        calc_margin();
    });
});
//-----------------------------------------------------------------------------------------------
// Helper Functions
//-----------------------------------------------------------------------------------------------
function validateEvent(e)
{
    if (e.cancelable)
        e.preventDefault();
    if (drag_counter > 2)
    {
        drag_counter = 0;
        return false;
    }
    return true;
}

function animateSidePanel(close) {
    clearTimerSafe(this.widthtimer);
    if (close)
    {
        $('.help').hide();
        $('.icon-help').removeClass('active');
        $('#side-panel').animate({left: -$('#side-panel').width() + 'px'}, 'fast');
        $('#cubes-overlay .wrapper').animate({left: 0 + 'px',
            width: 100 + '%'}, 'fast');
//        $('#menu-btn .close').fadeOut('slow');
//        $('#menu-btn .open').fadeIn('slow');
        $('#menu-btn .close').animate({marginLeft: -60 + 'px'}, 400);
        $('#menu-btn .open').animate({marginLeft: 0 + 'px'}, 400);
    }
    else
    {
        $('#side-panel').animate({left: 0 + 'px'}, 'fast');
        $('#cubes-overlay .wrapper').animate({left: $('#side-panel').width() + 'px',
            width: $(document).width() - 300 + 'px'}, 300);
//        $('#menu-btn .close').fadeIn('slow');
//        $('#menu-btn .open').fadeOut('slow');
        $('#menu-btn .close').animate({marginLeft: 0 + 'px'}, 400);
        $('#menu-btn .open').animate({marginLeft: 60 + 'px'}, 400);

        this.widthtimer = setTimeout(function () {
            $('#cubes-overlay .wrapper').css({
                width: 'calc(100% - ' + 300 + 'px)'});
        }, 400);
    }
}


function addTabFunctions()
{
    $('.tab-btn').on('touchend mousedown', function (e) {
        e.preventDefault();
        if (localStorage.getItem("active_tab") !== null)
        {
            localStorage.setItem(localStorage.getItem("active_tab") + '_scroll_pos',
                    $('#side-panel .scroll-area').scrollTop());
        }

        if (typeof activeMediaNumber !== 'undefined' && activeMediaNumber !== null)
        {
            hideMedia();
        }

        $('.tab-btn').removeClass('active');
        $(this).addClass('active');
        $('#side-panel .section, #side-panel .superior').hide();
        $('#side-panel .' + $(this).attr('id')).show();
        localStorage.setItem("active_tab", $(this).attr('id'));
        var s_p = localStorage.getItem($(this).attr('id') + '_scroll_pos');
        if (s_p !== null)
        {
            $('#side-panel .scroll-area').scrollTop(s_p);
        }
    });
}

function addElementFunction(el)
{
    $('#element-num-' + el.num).on('touchend mousedown', function (e) {
        if (!validateEvent(e))
            return;
        var el = activeProject.getElementbyNumber($(this).attr('marker-num'));
        if ($(this).hasClass('active'))
        {
            $(this).removeClass('active');
            $('.field .' + $(this).attr('id')).hide();
            el.visible = false;
            delete activeElement;
        }
        else
        {
            $(this).addClass('active');
            $('.field .' + $(this).attr('id')).show();
            el.visible = true;
            activeElement = el;
        }

        sendElementData();
        showActiveIcon();
        showToolbar();
    });
}

function addBBFunction(el)
{
    $('#element-num-' + el.num).on('touchend mousedown', function (e) {
        if (!validateEvent(e))
            return;
        if ($(this).hasClass('active'))
            return;
        var el = activeProject.getElementbyNumber($(this).attr('marker-num'));
        $('.BB .item').removeClass('active');
        $(this).addClass('active');
        setBackground(el.img);
        activeBBNumber = el.num;
        sendPlanChange($(this).attr('marker-num'), true);
    });
}

function addViewerFunction(el)
{
    $('#element-num-' + el.num).on('touchend mousedown', function (e) {
        if (!validateEvent(e))
            return;
        var active = $('#side-panel .section.VIEWER .item.active');
        if (active.length > 0 && active.attr('id') !== $(this).attr('id'))
            hideMedia();
        $('#side-panel .section.VIEWER .item').removeClass('active');
        var el = activeProject.getElementbyNumber($(this).attr('marker-num'));

        setTimeout(function () {
            sendMediaData(el.num, !el.v);
            showMedia(el.key);
        },100);
    });
}

function showMedia(key)
{
    var el = activeProject.getElementbyKey(key);
    el.v = 1;

    if (typeof activeMediaNumber !== 'undefined' && activeMediaNumber === el.num)
        return;


    activeMediaNumber = el.num;
    $('#element-num-' + el.num).addClass('active');
    if (el.type === 'SLIDESHOW')
    {

        $('#side-panel .scroll-area').append(
                '<div class="slideshow section pan-mode">' +
                '</div>');

        $('#side-panel .scroll-area').addClass('short');
        $('#side-panel .fixed-area').append(
                '<span class="header sub-element">' + el.title +
                '<span class="header-btn icon-close"></span></span>');
        $(el.media).each(function (id, el) {
            $('#side-panel .section.slideshow').append(
                    '<div class="item menu-element volatile ' +
                    ((id === 0) ? 'active' : '') + '">' +
                    '<span class="icon icon-image"></span>' +
                    '<span class="text">' + el.name + '</span>' +
                    '</div>');
            $('#side-panel .section.slideshow .item').last().attr('image-number', id);
        });
        $('.tab-btn').removeClass('active');
        $('#VIEWER').addClass('active');
        $('#side-panel .section, #side-panel .superior').hide();
        $('#side-panel .section.slideshow').show();
        $('#side-panel .superior.VIEWER').show();
        localStorage.setItem("active_tab", 'VIEWER');
        var s_p = localStorage.getItem('VIEWER_scroll_pos');
        if (s_p !== null)
        {
            $('#side-panel .scroll-area').scrollTop(s_p);
        }

        $('#side-panel .section.slideshow .text').ellipsis({
            row: 2
        });

        $('#cubes-overlay, #video').hide();
        $('#cubes-overlay, #swipe').show();
        $('#side-panel .section.VIEWER').hide();
        $('#side-panel .fixed-area .sub-element').on('touchend mousedown', function (e) {
            if (!validateEvent(e))
                return;
            hideMedia();
        });

        $('#side-panel .section.slideshow .item').on('touchend mousedown', function (e) {
            if (!validateEvent(e))
                return;
//            makeFirstSwipe(el);
//                sendMediaData(activeMediaNumber, 1, 0);
//            var img_num = parseInt($(this).attr('image-number'));
//            var cur_img_num = parseInt($('#side-panel .section.slideshow .item.active').attr('image-number'));
            $('#side-panel .section.slideshow .item').removeClass('active');
            $(this).addClass('active');
            changeBySwipe = false;
            activateMedia(el.key, $(this).attr('image-number'));
        });

    }
    else if (el.type === 'SINGLE_VIDEO')
    {
        $('#cubes-overlay, #swipe').hide();
        $('#cubes-overlay, #video').show();
    }
}


function hideMedia()
{
    if (typeof activeMediaNumber === 'undefined')
        return;
    $('#side-panel .scroll-area .slideshow').remove();
    $('#cubes-overlay, #swipe, #video').hide();
    $('#side-panel .scroll-area').removeClass('short');
    $('#side-panel .fixed-area .sub-element').remove();
    if ($('.tab-btn.active').attr('id') === 'VIEWER')
        $('#side-panel .section.VIEWER').show();
    $('#element-num-' + activeMediaNumber).removeClass('active');

    var el = activeProject.getElementbyNumber(activeMediaNumber);
    el.v = 0;
    sendMediaData(activeMediaNumber, false);
    activeMediaNumber = null;
}

function resetMoveMargins() {
    $('.toolbar').css('margin-right', 0);
    $('#menu-btn').css('margin-top', 0);
    $('#zoom-info').css('margin-top', 0);
}

function showToolbar()
{
    if ($('body').attr('id') === 'back-projection')
        return;

    $('.toolbar').show();
    $('.toolbar .scroll').hide();
    if (typeof activeElement !== 'undefined' && activeElement.type === 'camera')
    {
        if (activeElement.isLookAt)
            $('.toolbar .lookat').show();
        else
            $('.toolbar .camera').show();
    }
    else
    {
        $('.toolbar .marker').show();
    }



    if (modeZoom === 0 || backGroundNotFound)
    {
        $('#zoom').hide();
    }
    if (!exists($('.toolbar')[0].dragged))
        repositionMenu();
    if (typeof activeElement === 'undefined')
    {
        $('.toolbar').hide();
    }
}

//$('.toolbar').draggable({
//    axis: 'y',
//    distance: 15,
//    handle: '.drag',
//    containment: 'window',
//    drag: function ()
//    {
//        if (!exists(this.drag_counter))
//            this.drag_counter = 0;
//        this.drag_counter++;
//        if (this.drag_counter > 2)
//            this.dragged = true;
//    },
//    stop: function () {
//        this.drag_counter = 0;
//    }
//});

function hideToolbars()
{
    $('.right_open').each(function ()
    {
        $(this).animate({
            right: '-60px'
        }, animation_speed / 5);
    }
    );
    $('.toolbar').animate({
        right: '-60px'
    }, animation_speed / 5);
}

function repositionMenu(init)
{
    if ($('#back-projection').length > 0)
        return;
    var tb_height = $('.toolbar').height();
    var resizeFunction = function (selector, height) {

        if ($(selector).position() === null)
            return;
        var top = $(selector).position().top;
        if (top + height >= $(document).height())
        {
            $(selector).css({
                'top': ($(document).height() - height) + 'px'
//              'overflow-y':'scroll'
            });
        }
        if (height >= $(document).height())
        {
            if ($(selector).hasClass('ui-draggable'))
                $(selector).draggable('disable');
            $(selector).css({
                'top': 0 + 'px',
                'overflow-y': 'scroll'

            });
        }
        else
        {
            if ($(selector).hasClass('ui-draggable'))
                $(selector).draggable('enable');
            $(selector).ontouchmove = function (event) {
                if (!event.elementIsEnabled) {
                    event.preventDefault();
                }
            };

            $(selector).css({
                'overflow-y': 'visible'
            });
        }
    };
    $(window).resize(function () {
        resizeFunction('.toolbar', tb_height);
    });
    resizeFunction('.toolbar', tb_height);

    $('.toolbar').each(function ()
    {
        $(this).css('top', ($(document).height() - $(this).outerHeight(true)) / 2 + 'px');
    });
}