$(document).ready(function () {
    $('#swipe').on('mousedown mouseup touchstart touchmove touchend', function (e) {

        e.preventDefault();
        var data = e.originalEvent;
        if (e.originalEvent.constructor !== MouseEvent)
            data = e.originalEvent.touches[0];


        if (e.type === 'mousedown' || e.type === 'touchstart')
        {
            delete this.oldpageX;
            delete this.oldpageY;
            this.integrate_dx = 0;
            this.touchTime = now();
            this.pressed = true;
        }
        if (e.type === 'touchmove')
        {
            if (this.pressed)
            {
                this.integrate_dx -= data.pageX - this.oldpageX;
                if (this.integrate_dx > swipe_treshold)
                {
                    var dist = clamp(this.integrate_dx - swipe_treshold, 0, 50);
                    $('#swipe .next').css({marginRight: -(dist / 2) + 'px'});
                }
                else if (this.integrate_dx < -swipe_treshold)
                {
                    var dist = clamp(-this.integrate_dx - swipe_treshold, 0, 50);
                    $('#swipe .previous').css({marginLeft: -(dist / 2) + 'px'});
                }
            }
        }
        if (e.type === 'mouseup' || e.type === 'touchend' || e.type === 'touchcancel')
        {
            this.pressed = false;
            if (now() - this.touchTime < 500 && this.integrate_dx < swipe_treshold &&
                    this.integrate_dx > -swipe_treshold)
            {
                var el = activeProject.getElementbyNumber(activeMediaNumber);
                if (($('#swipe').outerWidth() / 2) < (this.oldpageX - $('#swipe').offset().left))
                {
                    moveToNextImg(el);
                    $('#swipe .next').animate({marginRight: '-50px'}, 50);

                }
                else
                {
                    moveToPrevImg(el);
                    $('#swipe .previous').animate({marginLeft: '-50px'}, 50);
                }
            }
            else
            {
                var el = activeProject.getElementbyNumber(activeMediaNumber);

                if (this.integrate_dx > swipe_treshold)
                {
                    moveToNextImg(el);
                }
                else if (this.integrate_dx < -swipe_treshold)
                {
                    moveToPrevImg(el);
                }
            }
            $('#swipe .next').animate({marginRight: '0px'}, 200);
            $('#swipe .previous').animate({marginLeft: '0px'}, 200);

        }
        if (exists(data))
        {
            this.oldpageX = data.pageX;
            this.oldpageY = data.pageY;
        }

    });

    $('#video').on('mousedown touchstart', function (e) {
        e.preventDefault();
        var el = activeProject.getElementbyNumber(activeMediaNumber);
        el.angle += 90;
        sendMediaData(el.num, 1, el.angle);
    });

});


function moveToNextImg(el)
{
    var el = activeProject.getElementbyNumber(activeMediaNumber);
    var img_num = parseInt($('#side-panel .section.slideshow .item.active').attr('image-number'));
    activateMedia(el.key,img_num + 1);
    changeBySwipe = true;
}

function moveToPrevImg(el)
{
    var el = activeProject.getElementbyNumber(activeMediaNumber);
    var img_num = parseInt($('#side-panel .section.slideshow .item.active').attr('image-number'));
    activateMedia(el.key,img_num - 1);
    changeBySwipe = true;
}