function createMenu()
{


    var overlay = "<div class=\"toolbar_overlay\" id=\"overlay\"> " +
            '  <div class="display"><span class="text"></span><span class="number"></span></div>' +
            "  <i class=\"icon-slideup\"></i> " +
            "  <i class=\"icon-slidedown\" style=\"top:60px;\"></i> " +
            '  <svg class="gear"></svg>' +
            "</div>";

    function moveOnToolbar(e)
    {
        e.preventDefault();

        if (e.type === 'mousedown' || e.type === 'touchstart')
        {
            hideToolbarControls();
            $('#overlay').remove();
            $(this).css('visibility', 'visible');
            $(this).append(overlay);
//            $('#overlay *').css('visibility', 'visible');
//            $('#overlay *').show();
        }
        console.log(e.type);
        if (e.type === 'touchmove' || e.type === 'mousemove')
        {
            var dist = e.clientY;
            if (isNaN(dist))
                dist = window.event.touches[0].pageY;
            if (!exists(this.olddist))
            {
                this.olddist = dist;
                return;
            }

            var delta = (this.olddist - dist);// / $(window).height()*750;
            this.olddist = dist;
            var minmax_reached = false;
            
            
            if ($('.toolbar #height').css('visibility') === 'visible')
            {
                activeElement.height -= delta;
                sendToolbarData(height_marker, activeElement.height);
                var bb = activeProject.getElementbyNumber(activeBBNumber);

                var h_percent = (activeElement.z - bb.oz) / (bb.zz - bb.oz) * 100;
                console.log(bb);
                $('.display .text').text('Height:');
                $('.display .number').text(Math.round(h_percent) + ' %');

                deb('changed height: h=' + activeElement.height, 'toolbar');
            }
            else if ($('.toolbar #tilt').css('visibility') === 'visible')
            {
                activeElement.tilt -= delta * 0.6;
//                activeElement.tilt = clamp(activeElement.tilt, -65,65);
                sendToolbarData(tilt_marker, activeElement.tilt);

                $('.display .text').text('Tilt:');
                $('.display .number').text(Math.round(activeElement.realtilt) + ' °');

                minmax_reached = activeElement.realtilt === -65 || activeElement.realtilt === 65;
//                moveGear(activeElement.realtilt,-65,65);
                deb('changed tilt: t=' + activeElement.tilt, 'toolbar');
            }
            else if ($('.toolbar #rotate').css('visibility') === 'visible')
            {
                activeElement.angle = (activeElement.angle + delta * 0.75) % 360;
                activeElement.angle += (activeElement.angle < 0) * 360;
                rotateElement();
                sendElementData();
                $('.display .text').text('Rotation:');
                $('.display .number').text(Math.round(activeElement.angle) + ' °');

                deb('changed angle: delta=' + delta, 'toolbar');
            }
            else if ($('.toolbar #zoom').css('visibility') === 'visible')
            {
                $('#zoom-info').hide();
                changeZoom(delta / 65);
                var z = Math.round(zoom * 10) / 10;
                $('.display .text').text('Zoom:');
                $('.display .number').text(z + ((z % 1 === 0) ? '.0' : '') + 'x');
                minmax_reached = z === 1 || z === maxZoom;
//                moveGear(6-zoom,1,maxZoom);
            }
            $('.display').show();
//            if (minmax_reached)
//            {
//                $('.display').css('opacity', '0.95');
//                clearTimerSafe(this.bouncetimer);
//                this.bouncetimer = setTimeout(function () {
//                    $('.display').fadeTo("slow", 0.4);
//                }, 400);
//            }
        }
        if (e.type === 'mouseup' || e.type === 'touchend' || e.type === 'touchcancel'
                || e.type === 'mouseout')
        {
            e.preventDefault();
            showToolbarControls();
            delete this.olddist;
            displayZoom();
        }
    }

    $('.toolbar .scroll').each(function ()
    {
        $(this).bind('touchend mouseup mousemove touchmove mousedown touchstart', moveOnToolbar);
    });

    $('.movebox').bind('mousemove mouseup touchend', moveOnToolbar);

}


function writeInfoText(text) {
    $('#info').css('display', 'block');
    $('#info').text(text);
    clearTimerSafe(this.bouncetimer);
    this.bouncetimer = setTimeout(function () {
        $('#info').fadeOut("slow");
    }, 2000);
}

function rotateElement(element)
{
    var marker = exists(element)?element:activeElement;
    if (marker.type === 'camera')
    {
        marker.markerHTML.find('.camera-rotate-handle').css({
            WebkitTransform: 'rotate(' + (-1 * marker.angle) + 'deg)',
            MozTransform: 'rotate(' + (-1 * marker.angle) + 'deg)',
            transform: 'rotate(' + (-1 * marker.angle) + 'deg)' // IE9
        });
    }
    else if (marker.type === 'marker')
    {
        marker.markerHTML.css({
            WebkitTransform: 'rotate(' + (-1 * marker.angle) + 'deg)',
            MozTransform: 'rotate(' + (-1 * marker.angle) + 'deg)',
            transform: 'rotate(' + (-1 * marker.angle) + 'deg)' // IE9
        });
    }
}


function hideToolbarControls()
{
    animateSidePanel(true);
    $('.toolbar div').css('visibility', 'hidden');
    $('.toolbar .separator').css('visibility', 'hidden');
    $('.toolbar .submenu').css('visibility', 'hidden');

    $('#right_close_marker').hide();
    $('#right_close_camera').hide();
    $('.movebox').show();
}

function showToolbarControls()
{
    $('.toolbar div').css('visibility', 'visible');
    $('.toolbar .separator').css('visibility', 'visible');
    $('.toolbar .submenu').css('visibility', 'visible');

    $('#overlay').remove();
    $('#right_close_marker').show();
    $('#right_close_camera').show();
    $('.movebox').hide();
}

