
changeZoom = function (delta) {
    if (delta === 0 || (modeZoom === 0) || backGroundNotFound)
        return;
    
    zoom = clamp(zoom + delta, 1, maxZoom);

    $('#background-img').css({
        'width': bgwidth * zoom + 'px',
        'height': bgheight * zoom + 'px'
    });

    zoomed_bg_h = $('#background-img').outerHeight(false);
    zoomed_bg_w = $('#background-img').outerWidth(false);
    zoomed_top = $('#background-img').offset().top;
    zoomed_left = $('#background-img').offset().left;

    recalcZoom();
};


displayZoom = function () {
    if (zoom > 1)
    {
        $('#zoom-info').show();
        var z = Math.round(zoom * 10) / 10;
        $('#zoom-info .text').text('Zoom:');
        $('#zoom-info .number').text(z + ((z % 1 === 0) ? '.0' : '') + 'x');
    }
    else
    {
        $('#zoom-info').hide();
    }
};

changeZoomTargetpx = function (x, y) {
    if ((x + y === 0) || modeZoom === 0)
        return;

    zoomTarget.x += x / zoomed_bg_w;
    zoomTarget.y += y / zoomed_bg_h;

    zoomTarget.x = clamp(zoomTarget.x, 0, 1);
    zoomTarget.y = clamp(zoomTarget.y, 0, 1);
};

recalcZoom = function () {
    if (modeZoom === 0 || typeof activeElement === 'undefined')
        return;

    var newzoom = (zoom < 1.01) ? 1 : zoom;
    zoom = newzoom;
    if (exists(this.oldzoom) && oldzoom === 1 && zoom === 1)
        return;

    var x = activeElement.posX;
    var y = 1 - activeElement.posY;
    if (modeZoom > 1)
    {
        x = zoomTarget.x;
        y = zoomTarget.y;
    }

    $('#background-img').css({
        'margin-top': -bgheight * (newzoom - 1) * y + offsetTop + 'px',
        'margin-left': -bgwidth * (newzoom - 1) * x + offsetLeft + 'px'
    });

    // faster:
    zoomed_top = Math.round((-bgheight * (newzoom - 1) * y + offsetTop) * 10) / 10;
    zoomed_left = Math.round((-bgwidth * (newzoom - 1) * x + offsetLeft) * 10) / 10;

    recalculateMarkersCameras();
    this.oldzoom = newzoom;
    deb('recalc zoom(x' + Math.round(zoom * 10) / 10 + ') ' +
            'target: x=' + Math.round(x * 100) / 100 + ' y=' + Math.round(y * 100) / 100 + ' ' +
            'offset: t=' + zoomed_top + 'px l=' +
            zoomed_left + 'px', 'zoom');
};